#pragma GCC optimize("O3")
#pragma GCC target ("sse4")
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll
using namespace std;
using namespace __gnu_pbds;
typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th
/// order_of_key(x) -> how many smaller

ll n, m, ansL, ansR;
matrix G, redici;
vector<vector<pair<ll, ll>>> Q;
vector<stack<ll>> zaqvka_na;
vector<ll> vajen_sum_na;

void dfs(ll u = 1, ll p = -1, ll d = 0){
    if(!zaqvka_na[d].empty()){
        vajen_sum_na[u] = zaqvka_na[d].top();
    }
    for(auto tmp : Q[u]){
        auto depth = tmp.fr;
        auto idx = tmp.sc;
        if(!zaqvka_na[d + depth].empty())redici[zaqvka_na[d + depth].top()].pb(idx);
        zaqvka_na[d + depth].push(idx);
    }
    for(auto v : G[u]){
        if(v != p){
            dfs(v, u, d + 1);
        }
    }
    for(auto tmp : Q[u]){
        auto depth = tmp.fr;
        auto idx = tmp.sc;
        zaqvka_na[d + depth].pop();
    }
}

int main(){
    /// ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n;
    G.resize(n + 1);
    Q.resize(n + 1);
    zaqvka_na.resize(n + 1);
    vajen_sum_na.resize(n + 1, -1);
    for(int i = 2; i <= n; i ++){
        int x; cin >> x;
        G[x].pb(i);
        G[i].pb(x);
    }
    cin >> m;
    redici.resize(m + 1);
    for(int i = 0; i < m; i ++){
        int u, k; cin >> u >> k;
        Q[u].pb({k, i});
    }
    dfs();
    row imp(m);
    for(int i = 0; i < m; i ++)
        if(redici[i].empty()) imp[i] = true;
    ll imps = count(all(imp), true);
    vector <pair<ll, ll>> A;
    for(int i = 1; i <= n; i ++){
        if(vajen_sum_na[i] != -1 && imp[vajen_sum_na[i]]){
            A.pb({i, vajen_sum_na[i]});
        }
    }
    row tmp(m);
    ll nw = 0, R = 0, L = 0;
    for(; R < A.size(); R ++){
        if(tmp[A[R].sc] == 0) ++ nw;
        ++ tmp[A[R].sc];
        if(nw == imps) break;
    }
    pair<ll, pair<ll, ll>> ans = {A[R].fr - A[L].fr + 1, {A[L].fr, A[R].fr}};
    for(; R < A.size(); R ++){
        while(L + 1 <= R && tmp[A[L].sc] > 1){
            tmp[A[L].sc] --;
            ++ L;
        }
        ans = min(ans, {A[R].fr - A[L].fr + 1, {A[L].fr, A[R].fr}});
        tmp[A[R].sc] ++;
    }
    cout << ans.sc.fr << " " << ans.sc.sc << endl;
}
