#include <algorithm>
#include <iostream>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXK = 100000;

int K;
int x[MAXK + 5], y[MAXK + 5];

long long calc(int x0, int y0)
{
    long long ret = 0, mx = 0;
    for (int i = 1; i <= K; ++ i)
    {
        ret += 1ll * abs(x0 - x[i]) + 1ll * abs(y0 - y[i]);
        mx = max(mx, 1ll * abs(x0 - x[i]) + 1ll * abs(y0 - y[i]));
    }
    ret = ret * 2 - mx;
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int m, n;
    cin >> m >> n;

    cin >> K;

    vector<int> vx, vy;
    for (int i = 1; i <= K; ++ i)
    {
        cin >> x[i] >> y[i];
        vx.push_back(x[i]);
        vy.push_back(y[i]);
    }

    sort(vx.begin(), vx.end());
    sort(vy.begin(), vy.end());

    cout << calc(vx[(K + 1) / 2 - 1], vy[(K + 1) / 2 - 1]) << endl;

    return 0;
}
