#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>
#include<vector>

using namespace std;

int p[200005];

vector<int> v[200005];

vector<int> children[200005];

int sum[200005];

void recursion(int now, int deep, int start)
{
    if(deep == 0)
    {
        v[now].push_back(start);

        return;
    }

    for(int i = 0;i < children[now].size();i++)
    {
        recursion(children[now][i], deep - 1, start);
    }
}

bool checkSums(int k)
{
    for(int i = 0;i < k;i++)
    {
        if(sum[i] == 0)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    int n, k;

    cin>>n;

    for(int i = 2;i <= n;i++)
    {
        cin>>p[i];

        children[p[i]].push_back(i);
    }

    cin>>k;

    for(int i = 0;i < k;i++)
    {
        int a, b;

        cin>>a>>b;

        recursion(a, b, i);
    }

    int s = 1;
    int e = n;

    int minS = s;
    int minE = e;

    for(int i = 1;i <= n;i++)
    {
        for(int j = 0;j < v[i].size();j++)
        {
            sum[v[i][j]]++;
        }

        if(checkSums(k))
        {
            e = i;

            break;
        }
    }

    minS = s;
    minE = e;

    //cout<<s<<" "<<e<<endl;

    for(int i = 2;i <= n;i++)
    {
        bool zero = false;

        for(int j = 0;j < v[i - 1].size();j++)
        {
            sum[v[i - 1][j]]--;

            if(sum[v[i - 1][j]] == 0)
            {
                zero = true;
            }
        }

        if(zero == false)
        {
            s = i;

            if(e - s < minE - minS)
            {
                minS = s;
                minE = e;
            }
        }
        else
        {
            bool found = false;

            for(int j = e + 1;j <= n;j++)
            {
                for(int q = 0;q < v[j].size();q++)
                {
                    sum[v[j][q]]++;
                }

                if(checkSums(k))
                {
                    s = i;

                    e = j;

                    found = true;

                    break;
                }
            }

            if(found == false)
            {
                break;
            }
        }
    }

    cout<<minS<<" "<<minE<<endl;

    return 0;
}
