#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>
#include<vector>

using namespace std;

long long p[200005];

vector<long long> v[200005];

vector<long long> children[200005];

long long sum[200005];

void recursion(long long now, long long deep, long long start)
{
    if(deep == 0)
    {
        v[now].push_back(start);

        return;
    }

    for(long long i = 0;i < children[now].size();i++)
    {
        recursion(children[now][i], deep - 1, start);
    }
}

bool checkSums(long long k)
{
    for(long long i = 0;i < k;i++)
    {
        if(sum[i] == 0)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    long long n, k;

    bool easy = true;

    cin>>n;

    for(long long i = 2;i <= n;i++)
    {
        cin>>p[i];

        if(p[i] != i - 1)
        {
            easy = false;
        }

        children[p[i]].push_back(i);
    }

    if(easy)
    {
        cin>>k;

        long long maxx = -1;
        long long minn = -1;

        for(long long i = 0;i < k;i++)
        {
            long long a,b;

            cin>>a>>b;
            if(a + b > maxx || maxx == -1)
            {
                maxx = a + b;
            }
            if(a + b < minn || minn == -1)
            {
                minn = a + b;
            }
        }
        cout<<minn<<" "<<maxx<<endl;

        return 0;
    }

    cin>>k;

    for(long long i = 0;i < k;i++)
    {
        long long a, b;

        cin>>a>>b;

        recursion(a, b, i);
    }

    long long s = 1;
    long long e = n;

    long long minS = s;
    long long minE = e;

    for(long long i = 1;i <= n;i++)
    {
        for(long long j = 0;j < v[i].size();j++)
        {
            sum[v[i][j]]++;
        }

        if(checkSums(k))
        {
            e = i;

            break;
        }
    }

    minS = s;
    minE = e;

    //cout<<s<<" "<<e<<endl;

    for(long long i = 2;i <= n;i++)
    {
        bool zero = false;
        long long numToFix = 0;

        for(long long j = 0;j < v[i - 1].size();j++)
        {
            sum[v[i - 1][j]]--;

            if(sum[v[i - 1][j]] == 0)
            {
                numToFix++;
                zero = true;
            }
        }

        if(zero == false)
        {
            s = i;

            if(e - s < minE - minS)
            {
                minS = s;
                minE = e;
            }
        }
        else
        {
            break;
        }
    }

    cout<<minS<<" "<<minE<<endl;

    return 0;
}
