#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>
#include<vector>

using namespace std;

long long p[200005];

vector<long long> v[200005];

vector<long long> children[200005];

long long sum[200005];

long long mins[200005];
long long maxs[200005];

void recursion(long long now, long long deep, long long start)
{
    if(deep == 0)
    {
        if(mins[start] > now || mins[start] == 0)
        {
            mins[start] = now;
        }

        if(maxs[start] < now)
        {
            maxs[start] = now;
        }

        return;
    }

    for(long long i = 0;i < children[now].size();i++)
    {
        recursion(children[now][i], deep - 1, start);
    }
}

bool checkSums(long long k)
{
    for(long long i = 0;i < k;i++)
    {
        if(sum[i] == 0)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    long long n, k;

    bool easy = true;

    cin>>n;

    for(long long i = 2;i <= n;i++)
    {
        cin>>p[i];

        if(p[i] != i - 1)
        {
            easy = false;
        }

        children[p[i]].push_back(i);
    }

    if(easy)
    {
        cin>>k;

        long long maxx = -1;
        long long minn = -1;

        for(long long i = 0;i < k;i++)
        {
            long long a,b;

            cin>>a>>b;
            if(a + b > maxx || maxx == -1)
            {
                maxx = a + b;
            }
            if(a + b < minn || minn == -1)
            {
                minn = a + b;
            }
        }
        cout<<minn<<" "<<maxx<<endl;

        return 0;
    }

    cin>>k;

    for(long long i = 0;i < k;i++)
    {
        long long a, b;

        cin>>a>>b;

        recursion(a, b, i);
    }

    int minMax = maxs[0];
    int maxMin = mins[0];

    for(int i = 1;i < k;i++)
    {
        if(maxs[i] < minMax)
        {
            minMax = maxs[i];
        }

        if(mins[i] > maxMin)
        {
            maxMin = mins[i];
        }
    }

    cout<<min(minMax, maxMin)<<" "<<max(minMax, maxMin)<<endl;

    return 0;
}
