#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=2e5+10;
vector <int> v[MAXN], que[MAXN];
int p[MAXN], start[MAXN];
void dfs(int x, int k, int ind) {
    if (k==0) {
        que[ind].push_back(x);
        return;
    }
    for (auto i:v[x]) {
        dfs(i,k-1,ind);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n;
    for (int i=2;i<=n;i++) cin >> p[i];
    cin >> q;
    int u, k;
    if (n<=3000 && q<=3000) {
        for (int i=2;i<=n;i++) {
            v[p[i]].push_back(i);
        }
        for (int i=0;i<q;i++) {
            cin >> u >> k;
            dfs(u,k,i);
        }
        for (int i=0;i<q;i++) {
            sort(que[i].begin(),que[i].end());
            start[i]=0;
        }
        int ansx=-1, ansy, cury;
        for (int i=1;i<=n;i++) {
            bool fl=true;
            for (int j=0;j<q;j++) {
                while (start[j]<que[j].size() && que[j][start[j]]<i) start[j]++;
                if (start[j]==que[j].size()) {
                    fl=false;
                    break;
                }
            }
            if (!fl) break;
            cury=que[0][start[0]];
            for (int j=1;j<q;j++) {
                cury=max(cury,que[j][start[j]]);
            }
            if (ansx==-1) {
                ansx=i;
                ansy=cury;
            } else if (ansy-ansx>cury-i) {
                ansx=i;
                ansy=cury;
            }
        }
        cout << ansx << ' ' << ansy << endl;
    } else {
        int maxs, mins;
        for (int i=0;i<q;i++) {
            cin >> u >> k;
            if (i==0) maxs=mins=u+k;
            else {
                maxs=max(maxs,u+k);
                mins=min(mins,u+k);
            }
        }
        cout << mins << ' ' << maxs << endl;
    }
    return 0;
}
