#include <iostream>
#include <vector>
using namespace std;
const int MAXN=2e5+10;
vector <int> v[MAXN];
int sp1[32][MAXN], sp2[32][MAXN];
int level[MAXN], l[MAXN], beg[MAXN], e[MAXN];
int n, maxst;
void dfs(int x) {
    for (auto i:v[x]) {
        level[i]=level[x]+1;
        dfs(i);
    }
    if (v[x].size()==0) sp1[0][x]=sp2[0][x]=-1;
    else {
        sp1[0][x]=v[x][0];
        sp2[0][x]=v[x][v[x].size()-1];
    }
}
void sparce_table() {
    maxst=0;
    int st=2;
    for (int i=1;st<n;i++) {
        for (int j=1;j<=n;j++) {
            if (sp1[i-1][j]==-1) sp1[i][j]=-1;
            else sp1[i][j]=sp1[i-1][sp1[i-1][j]];
            if (sp2[i-1][j]==-1) sp2[i][j]=-1;
            else sp2[i][j]=sp2[i-1][sp2[i-1][j]];
        }
        maxst=i;
        st*=2;
    }
}
int find_first(int x, int lev) {
    int st=maxst;
    while (st>=0) {
        if (sp1[st][x]!=-1 && level[sp1[st][x]]<=lev) x=sp1[st][x];
        st--;
    }
    return x;
}
int find_last(int x, int lev) {
    int st=maxst;
    while (st>=0) {
        if (sp2[st][x]!=-1 && level[sp2[st][x]]<=lev) x=sp2[st][x];
        st--;
    }
    return x;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int p;
    cin >> n;
    for (int i=2;i<=n;i++) {
        cin >> p;
        v[p].push_back(i);
    }
    level[1]=1;
    dfs(1);
    sparce_table();
    int q, u, x, minl, maxl;
    cin >> q;
    for (int i=0;i<q;i++) {
        cin >> u >> x;
        l[i]=level[u]+x;
        if (i==0) minl=maxl=l[i];
        else {
            minl=min(minl,l[i]);
            maxl=max(maxl,l[i]);
        }
        beg[i]=find_first(u,l[i]);
        e[i]=find_last(u,l[i]);
        ///cout << beg[i] << ' ' << e[i] << endl;
    }
    int ansbeg, anse;
    ansbeg=n+1;
    anse=0;
    for (int i=0;i<q;i++) {
        if (l[i]==minl) ansbeg=min(ansbeg,e[i]);
        if (l[i]==maxl) anse=max(anse,beg[i]);
    }
    if (ansbeg>anse) swap(ansbeg,anse);
    cout << ansbeg << ' ' << anse << endl;
    return 0;
}
