#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 3;
int parent[MAXN];
vector<int> graph[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++i) {
        cin >> parent[i];
        --parent[i];
        graph[parent[i]].push_back(i);
        graph[i].push_back(parent[i]);
    }

    int m;
    cin >> m;

    int l = n + 1, r = -1;
    for (int i = 0; i < m; ++i) {
        int vertex, level;
        cin >> vertex >> level;
        --vertex;

        l = min(l, vertex + level);
        r = max(r, vertex + level);
    }

    cout << l + 1 << " " << r + 1 << endl;
return 0;
}
