#include <iostream>
#include <string>
#include <algorithm>
using namespace std;
#define endl '\n'
#define int long long
string sum, x;
string tobinary(int val)
{
    string res;
    while(val > 0){
        int rem = val % 2; val /= 2;
        res.push_back(rem + '0');
    }
    reverse(res.begin(), res.end());
    return res;
}
bool fneed(int idx)
{
    if(idx == -1) return false;
    return (x[idx] != sum[idx]);
}
int todec(string s)
{
    int res = 0;
    int pow = 1;
    for(int i = 0; i < s.size(); ++i){
        if(s[i] == '1') res += pow;
        pow *= 2;
    }
    return res;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int ia, ib; cin >> ia >> ib;
    if(ia == 0 && ib == 0){
        cout << 0 << ' ' << 0 << endl; return 0;
    }
    sum = tobinary(ia); x = tobinary(ib);
    while(sum.size() < x.size()) sum.insert(sum.begin(), '0');
    while(x.size() < sum.size()) x.insert(x.begin(), '0');
    if(x[0] == '1' && sum[0] == '0'){
        cout << -1 << endl; return 0;
    }
    //cout << x << ' ' << sum << endl;
    for(int i = 1; i < sum.size(); ++i){
        if((x[i] == '1' && sum[i] == '0') && !fneed(i - 1)){
            cout << -1 << endl; return 0;
        }

        if((x[i] == '1' && sum[i] == '1') && fneed(i - 1)){
            cout << -1 << endl; return 0;
        }
    }
    bool prenos = false;
    string ans1, ans2;
    for(int i = sum.size() - 1; i >= 0; --i){
        if(x[i] == '0' && sum[i] == '0'){
            bool need = fneed(i - 1);
            if(need){
                ans1.push_back('1'); ans2.push_back('1');
            }
            else{
                ans1.push_back('0'); ans2.push_back('0');
            }
        }
        else if(x[i] == '0' && sum[i] == '1'){
            bool need = fneed(i - 1);
            if(need){
                ans1.push_back('1'); ans2.push_back('1');
            }
            else{
                ans1.push_back('0'); ans2.push_back('0');
            }
        }
        else if(x[i] == '1' && sum[i] == '0'){
            ans1.push_back('0'); ans2.push_back('1');
        }
        else if(x[i] == '1' && sum[i] == '1'){
            ans1.push_back('0'); ans2.push_back('1');
        }
    }
    //cout << ans1 << ' ' << ans2 << endl;
    cout << todec(ans1) << ' ' << todec(ans2) << endl;
    return 0;
}
