#include<iostream>
#include<vector>
using namespace std;

int broiVarhove;

int roditel[200010];

int broiZaqvki;

struct DanniZaZaqvka{
    int naKoi;
    int naKoeNivo;
};

DanniZaZaqvka zaqvki[200010];

vector<int> deca[200010];

int izbranoLqvo = 200010;
int izbranoDqsno = 0;

int naiMalkaRazlika = 200010;
int naimalkoLqvo = 200010;
int otgovorLqvo = 200010;
int otgovorDqsno = 0;

void proveri(){
    //cout<<"viknaha me da proverqvam kato izbranite sa ot "<<izbranoLqvo<<" do "<<izbranoDqsno<<endl;
    if(izbranoDqsno - izbranoLqvo + 1 < naiMalkaRazlika){
        naiMalkaRazlika = izbranoDqsno - izbranoLqvo + 1;
        otgovorLqvo = izbranoLqvo;
        otgovorDqsno = izbranoDqsno;
    }else{
        if(izbranoDqsno - izbranoLqvo + 1 == naiMalkaRazlika){
            if(izbranoLqvo < otgovorLqvo){
                otgovorLqvo = izbranoLqvo;
                otgovorDqsno = izbranoDqsno;
            }
        }
    }
}

void boqdisai(int naKoiSme){
    //cout<<naKoiSme<<" sega sme na "<<zaqvki[naKoiSme].naKoi<<" i iskame dete na nivo "<<zaqvki[naKoiSme].naKoeNivo<<endl;

    if(naKoiSme == 0){
        proveri();
    }

    if(zaqvki[naKoiSme].naKoeNivo == 1){
        int segashen = zaqvki[naKoiSme].naKoi;
        int originalnoLqvo = izbranoLqvo;
        int originalnoDqsno = izbranoDqsno;
        for(int i = 0; i < deca[segashen].size(); i++){
            izbranoLqvo = min(izbranoLqvo, deca[segashen][i]);
            izbranoDqsno = max(izbranoDqsno, deca[segashen][i]);
            //cout<<"izbrahme "<<deca[segashen][i]<<endl;
            boqdisai(naKoiSme - 1);
            izbranoLqvo = originalnoLqvo;
            izbranoDqsno = originalnoDqsno;
        }
    }else{
        int segashen = zaqvki[naKoiSme].naKoi;
        zaqvki[naKoiSme].naKoeNivo--;
        for(int i = 0; i < deca[segashen].size(); i++){
            zaqvki[naKoiSme].naKoi = deca[segashen][i];
            //cout<<"izbrahme "<<deca[segashen][i]<<endl;
            boqdisai(naKoiSme);
            zaqvki[naKoiSme].naKoi = segashen;
        }
        zaqvki[naKoiSme].naKoeNivo++;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>broiVarhove;

    for(int i = 2 ; i <= broiVarhove; i++){
        cin>>roditel[i];
        deca[roditel[i]].push_back(i);
    }

    cin>>broiZaqvki;

    if(broiVarhove <= 3000 && broiZaqvki <= 3000){
        for(int i = 1; i <= broiZaqvki; i++){
            cin>>zaqvki[i].naKoi>>zaqvki[i].naKoeNivo;
        }

        boqdisai(broiZaqvki);

        cout<<otgovorLqvo<<" "<<otgovorDqsno<<endl;
    }else{
        int minimalnoto = 200010;
        int maximalnoto = 0;

        for(int i = 1; i <= broiZaqvki; i++){
            int naKoiVrah;
            int koeNivo;

            cin>>naKoiVrah>>koeNivo;

            int ocvetqvame = naKoiVrah + koeNivo;

            minimalnoto = min(minimalnoto, ocvetqvame);
            maximalnoto = max(maximalnoto, ocvetqvame);
        }

        cout<<minimalnoto<<" "<<maximalnoto<<endl;
    }

    return 0;
}
