#include<iostream>
#include<stack>
using namespace std;

bool Check(int a, int b, int s)
{
    while(a>0 || b>0)
    {
        if(b%2==0)
        {
            if(a%2==0)
            {
                if(s==1)
                {
                    return true;
                }
                else
                {
                    if(Check(a/2, b/2, 0))
                    {
                        return true;
                    }
                    else if(Check(a/2, b/2, 1))
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
            }
            else
            {
                if(s==0)
                {
                    return false;
                }
                else
                {
                    if(Check(a/2, b/2, 0))
                    {
                        return true;
                    }
                    else if(Check(a/2, b/2, 1))
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
            }
        }
        else
        {
            if(a%2==0)
            {
                if(s==1)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                if(s==1)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
        }

        a/=2, b/=2;
    }

    return true;
}

pair<long long, long long> GetAns(int a, int b)
{
    stack<int> x, y;

    int s=0;
    while(a>0 || b>0)
    {
        if(b%2==0)
        {
            if(a%2==0)
            {
                if(s==1)
                {
                    x.push(0);
                    y.push(1);
                    s=1;
                }
                else
                {
                    if(Check(a/2, b/2, 0))
                    {
                        x.push(0);
                        y.push(0);
                        s=0;
                    }
                    else if(Check(a/2, b/2, 1))
                    {
                        x.push(1);
                        y.push(1);
                        s=1;
                    }
                    else
                    {
                        return {-1, 0};
                    }
                }
            }
            else
            {
                if(s==0)
                {
                    return {-1, 0};
                }
                else
                {
                    if(Check(a/2, b/2, 0))
                    {
                        x.push(0);
                        y.push(0);
                        s=0;
                    }
                    else if(Check(a/2, b/2, 1))
                    {
                        x.push(1);
                        y.push(1);
                        s=1;
                    }
                    else
                    {
                        return {-1, 0};
                    }
                }
            }
        }
        else
        {
            if(a%2==0)
            {
                if(s==1)
                {
                    x.push(0);
                    y.push(1);
                    s=1;
                }
                else
                {
                    return {-1, 0};
                }
            }
            else
            {
                if(s==1)
                {
                    return {-1, 0};
                }
                else
                {
                    x.push(0);
                    y.push(1);
                }
            }
        }

        a/=2, b/=2;
    }

    pair<long long, long long> ans=make_pair(0, 0);
    long long xs=x.size();
    while(xs--)
    {
        ans.first+=x.top()*(1<<xs);
        ans.second+=y.top()*(1<<xs);

        x.pop(), y.pop();
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    long long a, b;
    cin >> a >> b;

    pair<long long, long long> ans=GetAns(a, b);

    if(ans.first==-1)
    {
        cout << "-1\n";
        return 0;
    }

    cout << ans.first << " " << ans.second << "\n";

    return 0;
}
