#include<iostream>
#include<vector>
#include<cmath>
using namespace std;

const int MAXK=1e5;
const long long INF=1e18;

vector<pair<long long, long long> > v;
long long d[MAXK];
long long xsum=0, ysum=0;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    for(int i=0; i<k; i++)
    {
        long long a, b;
        cin >> a >> b;

        v.push_back({a, b});

        xsum+=a, ysum+=b;
    }

    long long x=ceil((xsum*1.0)/(k*1.0)), y=ceil((ysum*1.0)/(k*1.0)), maxd=0, maxIdx=-1;

    for(int i=0; i<k; i++)
    {
        d[i]=abs(v[i].first-x)+abs(v[i].second-y);
        if(d[i]>=maxd)
        {
            maxd=d[i], maxIdx=i;
        }
    }

    xsum=0, ysum=0;
    for(int i=0; i<k; i++)
    {
        if(i==maxIdx)
        {
            continue;
        }

        long long a=v[i].first, b=v[i].second;

        xsum+=a, ysum+=b;
    }

    x=ceil((xsum*1.0)/(k*1.0-1)), y=ceil((ysum*1.0)/(k*1.0-1));

    maxd=0;
    for(int i=0; i<k; i++)
    {
        d[i]=abs(v[i].first-x)+abs(v[i].second-y);
        maxd=max(maxd, d[i]);
    }

    long long ans=0;
    for(int i=0; i<k; i++)
    {
        if(d[i]==maxd)
        {
            ans+=d[i];
            maxd=-1;
        }
        else
        {
            ans+=2*d[i];
        }
    }

    cout << ans << "\n";

    return 0;
}
