#pragma GCC optimize("O3")
#pragma GCC target ("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th
/// order_of_key(x) -> how many smaller

int n, m;
matrix G, vajni_sa_mi;
vector<unordered_set<ll>> zaqvka_na;
vector<vector<pair<ll, ll>>> Q;
vector<pair<ll, ll>> dp;

void dfs_q(int u = 1, int p = -1, int d = 0){
    for(auto idx : zaqvka_na[d]){
        vajni_sa_mi[idx].pb(u);
    }
    for(auto tmp : Q[u]){
        auto depth = tmp.fr;
        auto idx = tmp.sc;
        zaqvka_na[d + depth].insert(idx);
    }
    for(auto v : G[u]){
        if(v != p){
            dfs_q(v, u, d + 1);
        }
    }
    for(auto tmp : Q[u]){
        auto depth = tmp.fr;
        auto idx = tmp.sc;
        zaqvka_na[d + depth].erase(idx);
    }
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n;
    G.resize(n + 1);
    Q.resize(n + 1);
    zaqvka_na.resize(n + 1);
    dp.resize(n + 1);
    for(int i = 2; i <= n; i ++){
        int x; cin >> x;
        G[i].pb(x);
        G[x].pb(i);
    }
    cin >> m;
    vajni_sa_mi.resize(m);
    for(int i = 0; i < m; i ++){
        int u, k; cin >> u >> k;
        Q[u].pb({k, i});
    }
    dfs_q();
    row mx = row(m), mn = row(m);
    for(int i = 0; i < m; i ++){
        mn[i] = *min_element(all(vajni_sa_mi[i]));
        mx[i] = *max_element(all(vajni_sa_mi[i]));
    }
    ll ans1 = *max_element(all(mn)), ans2 = *min_element(all(mx));
    cout << min(ans1, ans2) << " " << max(ans1, ans2) << endl;
}
