#pragma GCC optimize("O3")
#pragma GCC target ("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long
#define ld long double
#define bit(x) x&(-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th
/// order_of_key(x) -> how many smaller

int n, m, ansL, ansR;
matrix G, vajni_sa_mi, vajen_sum_na;
vector<vector<pair<ll, ll>>> Q;
vector<set<ll>> zaqvka_na;

void dfs(int u = 1, int p = -1, int d = 0){
    for(auto idx : zaqvka_na[d]){
        vajen_sum_na[u].pb(idx);
        vajni_sa_mi[idx].pb(u);
    }
    for(auto tmp : Q[u]){
        auto depth = tmp.fr;
        auto idx = tmp.sc;
        zaqvka_na[d + depth].insert(idx);
    }
    for(auto v : G[u]){
        if(v != p){
            dfs(v, u, d + 1);
        }
    }
    for(auto tmp : Q[u]){
        auto depth = tmp.fr;
        auto idx = tmp.sc;
        zaqvka_na[d + depth].erase(idx);
    }
}

bool ok(ll len){
    row tmp(m);
    for(int i = 1; i <= len; i ++){
        for(auto x : vajen_sum_na[i]){
            ++ tmp[x];
        }
    }
    ansL = 1;
    ansR = len;
    if(!count(all(tmp), 0)){
        return true;
    }
    for(int i = 1; i + len <= n; i ++){
        for(auto x : vajen_sum_na[i]) -- tmp[x];
        for(auto x : vajen_sum_na[i + len]) ++ tmp[x];
        ++ ansL;
        ++ ansR;
        if(!count(all(tmp), 0)){
            return true;
        }
    }
    return false;
}

int main(){
    /// ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n;
    G.resize(n + 1);
    Q.resize(n + 1);
    vajni_sa_mi.resize(m + 1);
    zaqvka_na.resize(n + 1);
    vajen_sum_na.resize(n + 1);
    for(int i = 2; i <= n; i ++){
        int x; cin >> x;
        G[x].pb(i);
        G[i].pb(x);
    }
    cin >> m;
    vajni_sa_mi.resize(m + 1);
    for(int i = 0; i < m; i ++){
        int u, k; cin >> u >> k;
        Q[u].pb({k, i});
    }
    dfs();

    ll l = 1, r = n;
    while(l < r){
        int m = (l + r) / 2;
        if(ok(m)) r = m;
        else l = m + 1;
    }
    ok(r);
    cout << ansL << " " << ansR << endl;
}
