#include <iostream>
#include <iomanip>

using namespace std;

typedef long long ll;

ll n,m,k;
ll a[1000000],b[1000000];

ll aabs(ll x)
{
	if(x>0) return x;
	return -x;
}

void init()
{
	scanf("%lld %lld",&m,&n);
	scanf("%lld",&k);
	for(int i=0;i<k;i++)
		scanf("%lld %lld",&a[i],&b[i]);
}

ll dist(ll x,ll y)
{
	ll ma=0,ret=0,z=0;
	
	for(ll i=0;i<k;i++)
	{
		z=aabs(a[i]-x)+aabs(b[i]-y);
		ret+=2*z;
		if(ma<z) ma=z;
	}
	
	return ret-ma;
}

int main()
{
	init();
	
	ll ans=dist(1,1);
	ll i=1,j=m,ij=(i+j)/2;
	ll temp=dist(ij,1);
	
	while(dist(ij-1,1)<temp||temp>dist(ij+1,1))
	{
		if(temp>dist(ij+1,1))
			i=ij+1;
		else
			j=ij-1;

		ij=(i+j)/2;
		temp=dist(ij,1);
	}
	//cout<<ij<<endl;

	i=1;j=n;
	ll ijj=(i+j)/2;
	temp=dist(ij,ijj);
	
	while(dist(ij,ijj-1)<temp||temp>dist(ij,ijj+1))
	{
		if(temp>dist(ij,ijj+1))
			i=ijj+1;
		else j=ijj-1;
		
		ijj=(i+j)/2;
		temp=dist(ij,ijj);
	}
	//cout<<ijj<<endl;
	
	cout<<dist(ij,ijj)<<endl;
	
/*	for(ll j=1;j<=n;j++)
	{
		for(ll i=1;i<=m;i++)
		{
			cout<<setw(3)<<dist(i,j);
		}
		cout<<endl;
	}*/
}