#include <iostream>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXK = 100000;

int K;
int x[MAXK + 5], y[MAXK + 5];

long long calc(int x0, int y0)
{
    long long ret = 0, mx = 0;
    for (int i = 1; i <= K; ++ i)
    {
        ret += 1ll * abs(x0 - x[i]) + 1ll * abs(y0 - y[i]);
        mx = max(mx, 1ll * abs(x0 - x[i]) + 1ll * abs(y0 - y[i]));
    }
    ret = ret * 2 - mx;
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int m, n;
    cin >> m >> n;

    cin >> K;

    long long sumx = 0, sumy = 0;
    for (int i = 1; i <= K; ++ i)
    {
        cin >> x[i] >> y[i];
        sumx += x[i];
        sumy += y[i];
    }

    int x0 = sumx / K, y0 = sumy / K;
    int x1 = x0 + 1, y1 = y0 + 1;

    cout << min(min(calc(x0, y0), calc(x0, y1)), min(calc(x1, y0), calc(x1, y1))) << endl;

    return 0;
}
