#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXK = 1000000;

long long x[MAXK + 5], y[MAXK + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    long long m, n;
    cin >> m >> n;

    long long K;
    cin >> K;

    vector<long long> vx, vy;
    for (int i = 1; i <= K; ++ i)
    {
        cin >> x[i] >> y[i];
        vx.push_back(x[i]);
        vy.push_back(y[i]);
    }

    sort(vx.begin(), vx.end());
    sort(vy.begin(), vy.end());

    long long xmin = vx[(K + 1) / 2 - 1], xmax = vx[(K + 2) / 2 - 1];
    long long ymin = vy[(K + 1) / 2 - 1], ymax = vy[(K + 2) / 2 - 1];

    long long mx = 0;
    for (int i = 1; i <= K; ++ i)
    {
        long long s = 0;
        if (x[i] <= xmin) s += xmax - x[i];
        else s += x[i] - xmin;
        if (y[i] <= ymin) s += ymax - y[i];
        else s += y[i] - ymin;
        mx = max(mx, s);
    }

    long long ans = 0;
    for (int i = 0; i < K / 2; ++ i)
    {
        ans += (vx[K - 1 - i] - vx[i]);
        ans += (vy[K - 1 - i] - vy[i]);
    }

    ans *= 2;
    ans -= mx;

    cout << ans << endl;

    return 0;
}
