#include<bits/stdc++.h>
#define endl '\n'
#define space ' '
using namespace std;

const int MAXV = 1e+7+100;
const int MAXK = 1e+5+100;
int posXamount[MAXV], posYamount[MAXV];
int points[MAXK][2];
int m, n, cx, cy;
int k;
int travelValX[MAXV], travelValY[MAXV];

void Input()
{
    memset(posXamount, 0, sizeof(posXamount));
    memset(posYamount, 0, sizeof(posYamount));
    cin >> m >> n;
    cin >> k;
    for(int i = 0; i < k; i++)
    {
        cin >> cx >> cy;
        points[i][0] = cx;
        points[i][1] = cy;
        posXamount[cx]++;
        posYamount[cy]++;
    }
}

void CalculatePath()
{
    int unitsCount = 0, valAmount = 0;
    for(int i = 1; i <= m; i++)
    {
        travelValX[i] += valAmount;
        unitsCount += posXamount[i];
        valAmount += unitsCount;
    }
    unitsCount = 0; valAmount = 0;
    for(int i = m; i >= 1; i--)
    {
        travelValX[i] += valAmount;
        unitsCount += posXamount[i];
        valAmount += unitsCount;
    }

    unitsCount = 0, valAmount = 0;
    for(int i = 1; i <= n; i++)
    {
        travelValY[i] += valAmount;
        unitsCount += posYamount[i];
        valAmount += unitsCount;
    }
    unitsCount = 0; valAmount = 0;
    for(int i = n; i >= 1; i--)
    {
        travelValY[i] += valAmount;
        unitsCount += posYamount[i];
        valAmount += unitsCount;
    }
}

void Solve()
{
    int minXval = INT_MAX, minYval = INT_MAX, minXcoord, minYcoord;
    for(int i = 1; i <= m; i++)
    {
        if(minXval > travelValX[i])
        {
            minXval = travelValX[i];
            minXcoord = i;
        }
    }

    for(int i = 1; i <= n; i++)
    {
        if(minYval > travelValY[i])
        {
            minYval = travelValY[i];
            minYcoord = i;
        }
    }

    int val = (minXval + minYval) * 2;
    int maxDist = 0;

    for(int i = 0; i < k; i++)
    {
        maxDist = max(maxDist, abs(minXcoord - points[i][0]) + abs(minYcoord - points[i][1]));
    }
    val-=maxDist;
    cout << val << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Input();
    CalculatePath();
    Solve();
    return 0;
}
