#include<bits/stdc++.h>
#define endl '\n'
#define space ' '
#define llong long long
using namespace std;

const int MAXK = 1e+5+100;
llong points[MAXK][2];
llong coordsX[MAXK], coordsY[MAXK];
llong m, n, cx, cy;
llong k;

llong MaxDistToRect(llong rectXmin, llong rectXmax, llong rectYmin, llong rectYmax, llong pointX, llong pointY)
{
    return max( abs(rectXmin - pointX), abs(rectXmax - pointX) )
        + max( abs(rectYmin - pointY), abs(rectYmax - pointY) );
}

void Input()
{
    cin >> m >> n;
    cin >> k;
    for(int i = 0; i < k; i++)
    {
        cin >> cx >> cy;
        points[i][0] = cx;
        points[i][1] = cy;
        coordsX[i] = cx;
        coordsY[i] = cy;
    }
}

void Solve()
{
    llong minCoordX, maxCoordX, minCoordY, maxCoordY;
    /// Calculating min x length
    sort(coordsX, coordsX+k);
    llong minXlength = 0;
    for(int i = 0; i < k/2; i++)
        minXlength += coordsX[k-i-1]-coordsX[i];

    minCoordX = maxCoordX = coordsX[k/2];
    if(k % 2 == 0) minCoordX = coordsX[k/2-1];

    /// Calculating min y length
    sort(coordsY, coordsY+k);
    llong minYlength = 0;
    for(int i = 0; i < k/2; i++)
        minYlength += coordsY[k-i-1]-coordsY[i];

    minCoordY = maxCoordY = coordsY[k/2];
    if(k % 2 == 0) minCoordY = coordsY[k/2-1];

    llong val = (minXlength+minYlength)*2;

    llong maxDist = 0;

    for(int i = 0; i < k; i++)
    {
        maxDist = max(maxDist, MaxDistToRect(minCoordX, maxCoordX, minCoordY, maxCoordY, points[i][0], points[i][1]));
    }

    val-=maxDist;
    cout << val << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    Input();
    Solve();
    return 0;
}
