#include<bits/stdc++.h>
#define space ' '
using namespace std;

const int MAXN = 2e+5+10;

struct node
{
    int parent;
    int maxIndexChild;
    int minIndexChild;
};

node nodes[MAXN];
int n, m;

int GetMinIndex(int start, int depth)
{
    int currentI = start;
    while(depth > 0)
    {
        if(nodes[currentI].minIndexChild != -1)
        {
            currentI = nodes[currentI].minIndexChild;
            depth--;
        }
        else if(nodes[currentI].maxIndexChild != -1)
        {
            currentI = nodes[currentI].maxIndexChild;
            depth--;
        }
        else
        {
            currentI = nodes[currentI].parent;
            depth++;
        }
    }
    return currentI;
}

int GetMaxIndex(int start, int depth)
{
    int currentI = start;
    while(depth > 0)
    {
        if(nodes[currentI].maxIndexChild != -1)
        {
            currentI = nodes[currentI].maxIndexChild;
            depth--;
        }
        else if(nodes[currentI].minIndexChild != -1)
        {
            currentI = nodes[currentI].minIndexChild;
            depth--;
        }
        else
        {
            currentI = nodes[currentI].parent;
            depth++;
        }
    }
    return currentI;
}

int main()
{
    cin >> n;
    nodes[1].parent = 1;
    nodes[1].minIndexChild = -1;
    int q;
    for(int i = 1; i < n; i++)
    {
        cin >> q;
        nodes[i+1].parent = q;
        nodes[i+1].minIndexChild = -1;
        nodes[i+1].maxIndexChild = -1;

        nodes[q].maxIndexChild = i+1;
        //cout << nodes[q].maxIndexChild << endl;
        if(nodes[q].minIndexChild == -1)
            nodes[q].minIndexChild = i+1;
    }

//    for(int i = 1; i <= n; i++)
//    {
//        cout << i << space << nodes[i].parent << space << nodes[i].minIndexChild << space << nodes[i].maxIndexChild << endl;
//    }

    int maxIndex = 0, minIndex = n+1;
    cin >> m;
    int start, children;

    for(int i = 0; i < m; i++)
    {
        cin >> start >> children;
        int mi = GetMinIndex(start, children);
        int ma = GetMaxIndex(start, children);
        if(mi > maxIndex)
            maxIndex = mi;
        if(ma < minIndex)
            minIndex = ma;
    }

    cout << minIndex << space << maxIndex << endl;

    return 0;
}
