#include<iostream>
#include<string>
#include<queue>
#include<stack>
#include<math.h>
#include<algorithm>

using namespace std;

long long x[100000];
long long y[100000];

long long dis(long long xNow,long long yNow, long long k)
{
    long long maxx = abs(x[0] - xNow) + abs(y[0] - yNow);

    long long sum = maxx * 2;

    for(long long i = 1;i < k;i++)
    {
        sum += 2 * (abs(x[i] - xNow) + abs(y[i] - yNow));
        if(abs(x[i] - xNow) + abs(y[i] - yNow) > maxx)
        {
            maxx = (abs(x[i] - xNow) + abs(y[i] - yNow));
        }
    }

    sum -= maxx;

    return sum;
}

long long minn = -1;

void recursion(int xNow, int yNow, int k, int n, int m)
{
    if(xNow < 0 || xNow >= n || yNow < 0 || yNow >= m)
    {
        return;
    }

    if(minn <= dis(xNow, yNow, k) && minn != -1)
    {
        return;
    }

    minn = dis(xNow, yNow, k);

    recursion(xNow + 1, yNow, k, n, m);

    recursion(xNow, yNow + 1, k, n, m);

    recursion(xNow - 1, yNow, k, n, m);

    recursion(xNow, yNow - 1, k, n, m);
}

int main()
{
    long long n;
    long long m;
    long long k;

    cin>>n>>m>>k;

    long long xSum = 0;
    long long ySum = 0;

    for(long long i = 0;i < k;i++)
    {
        cin>>x[i]>>y[i];

        x[i]--;
        y[i]--;

        xSum += x[i];
        ySum += y[i];
    }

    recursion(0,0,k,n,m);

    cout<<minn<<endl;

    return 0;
}

/*
5 4
4
3 4
1 1
5 3
4 1
*/
