#include <bits/stdc++.h>
using namespace std;

int n, m, nom;
int parent[200003], znode[200003], zlevel[200003];
int level[200003], nomer[200003], sub_d[200003];
vector <int> nbs[200003];
bool t;
unordered_set <int> z[3002];

void dfs (int curr) {
    if (nbs[curr].size() == 1 and curr != 1) {
        sub_d[curr] = 1;
        return;
    }
    for (int i=0; i < nbs[curr].size(); i++) {
        int currn = nbs[curr][i];
        if (currn == parent[curr]) {continue;}
        nom++;
        nomer[currn] = nom;
        dfs (currn);
        sub_d[curr] += 1 + sub_d[currn];
    }
}

bool check (int i, int j, int k) {
    if (level[i] != level[j] + k) {return false;}
    if (nomer[i] - nomer[j] > sub_d[j] or nomer[i] - nomer[j] < 0) {return false;}
    return true;
}

int check1 (int d) {
    for (int i=1; i <= n-d+1; i++) {
        bool f = true;
        for (int j=0; j < m; j++) {
            int cnt=0;
            for (int k=i; k <= i+d-1; k++) {
                if (z[k].find(j) != z[k].end()) {cnt++;}
            }
            //cout << cnt << endl;
            if (cnt == 0) {f = false; break;}
        }
        if (f == true) {
            return i;
        }
    }
    return -1;
}

int main () {
ios_base::sync_with_stdio(false);
cout.tie(0); cin.tie(0);

cin >> n;

parent[1] = 1;
level[1] = 1;
nomer[1] = 1;
nom = 1;
for (int i=2; i <= n; i++) {
    cin >> parent[i];
    level[i] = 1 + level[parent[i]];
    nbs[parent[i]].push_back(i);
    if (parent[i] != i-1) {t = true;}
}

dfs(1);

cin >> m;

for (int i=0; i < m; i++) {
    cin >> znode[i] >> zlevel[i];
}

/**for (int i=1; i <= n; i++) {
    cout << i << ": " << nomer[i] << " " << level[i] << " " << sub_d[i] << endl;
}**/

if (t == false) {
    int mini = 1000000000, maxi=-1;
    for (int i=0; i < m; i++) {
        mini = min (mini, znode[i] + zlevel[i]);
        maxi = max (maxi, znode[i] + zlevel[i]);
    }
    cout << mini << " " << maxi << endl;
    return 0;
}

for (int i=1; i <= n; i++) {
    for (int j=0; j < m; j++) {
        if (check (i, znode[j], zlevel[j]) == true) {
            z[i].insert(j);
        }
    }
}

int l=1, r=n, mid;

/**for (int i=1; i <= n; i++) {
        cout << i << ": ";
        for (int j=0; j < z[i].size(); j++) {
            cout << z[i][j] << " ";
        }
        cout << endl;
}**/

//cout << check1(3) << endl;

int ansi;

while (l < r) {
    mid = (l+r)/2;
    //cout << l << " " << r << " " << mid << endl;
    int x = check1(mid);
    if (x != -1) {
        ansi = x;
        r=mid;
    }
    else {
        l=mid+1;
    }
}

cout << ansi << " " << ansi + l - 1 << endl;

return 0;
}