//                                             zad3
#include <bits/stdc++.h>
using namespace std;

struct Vruh{

    Vruh(int nom, int lvl, int rod){
        this->nom = nom;
        this->lvl = lvl;
        this->rod = rod;
    }

    int nom = 0;
    int lvl = 0;
    int prviNasl = -1, brNasl = 0;
    int rod = 0;

    void print(){
        cout << "nom: " << nom << ", lvl: " << lvl << ", rod: " << rod << ", prviNasl: " << prviNasl << ", brNasl: " << brNasl << endl;
    }

};

int k;
vector<Vruh> vrs;


struct Predlojenie{

    Predlojenie(int vr, int dalb){
        this->vr = vr;
        this->dalb = dalb;

        this->sb = vrs[vr].lvl + dalb;
    }

    int vr;
    int dalb;

    int sb;

    void print(){
        cout << "vr: " << vr << ", dalb: " << dalb << endl;
    }
};


vector<Predlojenie> predl;
int pr;


int maxNalqwo(int indx, int dalb){
    if(dalb == 0) return indx;

    if(vrs[indx].prviNasl == -1) return -1;
    int otg = maxNalqwo(vrs[indx].prviNasl, dalb - 1);

    if(otg == -1){
        for(int i=vrs[indx].prviNasl + 1;i< vrs[indx].prviNasl + vrs[indx].brNasl;i++){
            otg = maxNalqwo(i, dalb - 1);
            if(otg != -1) return otg;
        }
    }

}

int maxNadqsno(int indx, int dalb){
    if(dalb == 0) return indx;

    if(vrs[indx].prviNasl == -1) return -1;
    int otg = maxNadqsno(vrs[indx].prviNasl + vrs[indx].brNasl - 1, dalb - 1);

    if(otg == -1){
        for(int i=vrs[indx].prviNasl + vrs[indx].brNasl - 2;i>=vrs[indx].prviNasl;i--){
            otg = maxNadqsno(i, dalb - 1);
            if(otg != -1) return otg;
        }
    }
}

int main(){
    vrs.push_back(Vruh(0, 1, -1));
    cin >> k;

    int _n;
    for(int i=1;i<k;i++){
        cin >> _n;
        _n--;

        Vruh seg(i, vrs[_n].lvl + 1, _n);
        vrs.push_back(seg);

        if(vrs[_n].brNasl == 0) vrs[_n].prviNasl = i;
        vrs[_n].brNasl++;

    }

    cin >> pr;
    int _a, _b;
    for(int i=0;i<pr;i++){
        cin >> _a >> _b;
        _a--;

        Predlojenie s(_a, _b);
        predl.push_back(s);
    }


    for(int i=0; i<pr; i++)
    {
        int sb = predl[i].sb;

        for(int j=0; j<pr; j++)
        {
            if(i == j) continue;

            if(predl[j].sb == sb)
            {
                if(predl[i].dalb > predl[j].dalb || (predl[i].vr == predl[j].vr))
                {
                    //dlt i ret

                    predl.erase(predl.begin() + i);
                    i--;
                    pr--;

                    break;
                }
            }
        }
    }

    int maxIndx = 0;
    int minIndx = 0;

    for(int i=0;i<pr;i++){
        //predl[i].print();

        if(predl[i].sb > predl[maxIndx].sb || (predl[i].sb == predl[maxIndx].sb && predl[i].vr > predl[maxIndx].vr)){
            maxIndx = i;
        }

        if(predl[i].sb < predl[minIndx].sb || (predl[i].sb == predl[minIndx].sb && predl[i].vr < predl[maxIndx].vr)){
            minIndx = i;
        }
    }

    //cout << maxIndx << " " << minIndx;

    int nach, kr;
    if(maxIndx != minIndx){
        nach = maxNalqwo(predl[maxIndx].vr, predl[maxIndx].dalb);
        kr = maxNadqsno(predl[minIndx].vr, predl[minIndx].dalb);
    } else{
        kr = maxNalqwo(predl[maxIndx].vr, predl[maxIndx].dalb);
        nach = kr;
    }

    cout << kr + 1 << " " << nach + 1;

    return 0;
}
