#include <iostream>
#include <utility>
#include <algorithm>
#include <math.h>

using namespace std;

int fromBinaryToInt(string binary){
    int number = 0, multyplier = 1;

    for(int i = binary.length()-1; i >= 0; i--){
        number += (binary[i] - '0') * multyplier;
        multyplier *= 2;
    }

    return number;
}

int fromBinaryToInt1(int binary){
    int number = 0, multyplier = 1;
    while (binary != 0){
        int thisNum = binary%10;
        binary = binary/10;
        number += thisNum * multyplier;
        multyplier *= 2;
    }

    return number;
}

string fromIntToBinary(int number){
    string binary = "0";
    while (number != 0){
        if(number%2 == 1){
            binary[0] = '1';
            number--;
        }else{
            binary = (string)"0" + (string)binary;
            number = number/2;
        }
    }

    return binary;
}

string myXOR(string str1, string str2){
    string output = "";

    if(str2.length() > str1.length()){
        string a = str2;
        str2 = str1;
        str1 = a;
    }

    while(str1.length() > str2.length()){
        str2 = (string)"0" + str2;
    }

    for(int i = 0; i < str1.length(); i++){
        if(str1[i] == str2[i]){
            output = (string)output + (string)"0";
        }else{
            output = (string)output + (string)"1";
        }
    }

    return output;
}

bool checkNumbers(int A, int B, int X, int Y){
    if(X > Y){
        return false;
    }

    if(X+Y != A){
        return false;
    }

    if(fromBinaryToInt(myXOR(fromIntToBinary(X), fromIntToBinary(Y))) != B){
        return false;
    }

    return true;
}

int A, B, X = 0, Y = 1;

int main(){

    cin>>A>>B;

    int i = 0;
    bool hasFound = false;
    while(X < Y){
        Y = A-i;
        X = i;
        i++;
        if(checkNumbers(A, B, X, Y) == true){
            cout<<X<<" "<<Y<<endl;
            hasFound = true;
            break;
        }
    }
    if(hasFound == false){
        cout<<-1<<endl;
    }

    /*for(int i = 0; i < 20 ; i++){
        cout<<"for the number "<<i<<" the program returns "<<fromIntToBinary1(i)<<endl;
        cout<<"for the number "<<i<<" the program returns "<<fromBinaryToInt1(fromIntToBinary1(i))<<endl;
        cout<<"-------------------------------------------------------------"<<endl;
    }*/

    return 0;
}
