#include <iostream>
#include <utility>
#include <algorithm>
#include <math.h>

using namespace std;

int fromBinaryToInt(string binary){
    int number = 0, multyplier = 1;

    for(int i = binary.length()-1; i >= 0; i--){
        number += (binary[i] - '0') * multyplier;
        multyplier *= 2;
    }

    return number;
}

int fromBinaryToInt1(int binary){
    int number = 0, multyplier = 1;
    while (binary != 0){
        int thisNum = binary%10;
        binary = binary/10;
        number += thisNum * multyplier;
        multyplier *= 2;
    }

    return number;
}

string fromIntToBinary(int number){
    string binary = "0";
    while (number != 0){
        if(number%2 == 1){
            binary[0] = '1';
            number--;
        }else{
            binary = (string)"0" + (string)binary;
            number = number/2;
        }
    }

    return binary;
}

string myXOR(string str1, string str2){
    string output = "";

    if(str2.length() > str1.length()){
        string a = str2;
        str2 = str1;
        str1 = a;
    }

    while(str1.length() > str2.length()){
        str2 = (string)"0" + str2;
    }

    for(int i = 0; i < str1.length(); i++){
        if(str1[i] == str2[i]){
            output = (string)output + (string)"0";
        }else{
            output = (string)output + (string)"1";
        }
    }

    return output;
}

bool checkNumbers(int A, int B, int X, int Y){
    if(X > Y || X > A || X > B){
        return false;
    }

    if(X+Y != A){
        return false;
    }

    if(fromBinaryToInt(myXOR(fromIntToBinary(X), fromIntToBinary(Y))) != B){
        return false;
    }

    return true;
}

int A, B, X = 0, Y = 1;
int aNum = 0;

bool reverseXOR(string theXOR, int index, string num1, string num2){
    //cout<<"-----------------------"<<endl;
    //cout<<"num1: "<<num1<<" num2: "<<num2<<endl;
    //cout<<"-----------------------"<<endl;

    if(index != 0){
        X = fromBinaryToInt(num1);
        Y = fromBinaryToInt(num2);
        /*aNum++;
        if(X == 33 || X == 109 || Y == 33 || Y == 109){
            cout<<A<<" "<<B<<" "<<X<<" "<<Y<<endl;
        }*/
        if(checkNumbers(A, B, X, Y) == true){
            cout<<X<<" "<<Y<<endl;
            return true;
        }
    }

    if(index < theXOR.length()){
        if(theXOR[theXOR.length()-index-1] == '0'){
            if((fromBinaryToInt((string)"0"+(string)num1)+fromBinaryToInt((string)"0"+(string)num2)) > A){
                return false;
            }
            if(reverseXOR(theXOR, index+1, (string)"0"+(string)num1, (string)"0"+(string)num2) == true){
                return true;
            }
            if((fromBinaryToInt((string)"1"+(string)num1)+fromBinaryToInt((string)"1"+(string)num2)) > A){
                return false;
            }
            if(reverseXOR(theXOR, index+1, (string)"1"+(string)num1, (string)"1"+(string)num2) == true){
                return true;
            }
        }else{
            if((fromBinaryToInt((string)"0"+(string)num1)+fromBinaryToInt((string)"1"+(string)num2)) > A){
                return false;
            }
            if(reverseXOR(theXOR, index+1, (string)"0"+(string)num1, (string)"1"+(string)num2) == true){
                return true;
            }
            if((fromBinaryToInt((string)"1"+(string)num1)+fromBinaryToInt((string)"0"+(string)num2)) > A){
                return false;
            }
            if(reverseXOR(theXOR, index+1, (string)"1"+(string)num1, (string)"0"+(string)num2) == true){
                return true;
            }
        }
        return false;
    }else{
        return false;
    }
}

int main(){
    //cout<<"142: "<<fromIntToBinary(142)<<"  76: "<<fromIntToBinary(76)<<"   33: "<<fromIntToBinary(33)<<"   109: "<<fromIntToBinary(109)<<endl;
    while(true){
        cin>>A>>B;

        //cout<<(string)"000"+fromIntToBinary(B)<<endl;
        /*if(reverseXOR((string)"000"+(string)fromIntToBinary(B), 0, "", "") == false){
            cout<<-1<<endl;
        }*/

        //cout<<aNum<<endl;
        int i = 0;
        bool hasFound = false;
        while(X < Y){
            Y = A-i;
            X = i;
            i++;
            if(checkNumbers(A, B, X, Y) == true){
                cout<<X<<" "<<Y<<endl;
                hasFound = true;
                break;
            }
        }
        if(hasFound == false){
            cout<<-1<<endl;
        }
    }

    /*for(int i = 0; i < 20 ; i++){
        cout<<"for the number "<<i<<" the program returns "<<fromIntToBinary1(i)<<endl;
        cout<<"for the number "<<i<<" the program returns "<<fromBinaryToInt1(fromIntToBinary1(i))<<endl;
        cout<<"-------------------------------------------------------------"<<endl;
    }*/

    return 0;
}
