#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

const int N=2e5+10;
int n, q, l1, l2, mlvl=0, k, r, ansl=0, ansr=0, ans;
int used[N], lvl[N], p[N];
vector<int> ver[N];

struct edge
{
    int v, d;
    edge() { }
    edge(int v, int d) :v(v), d(d) { }
    bool operator< (const edge &o) const
    {
        if(lvl[v]+d==lvl[o.v]+o.d)
        {
            if(lvl[v]==lvl[o.v])
                return v>o.v;
            return (lvl[v]>lvl[o.v]);
        }
        return(lvl[v]+d>lvl[o.v]+o.d);
    }
} a[N];

void dfs(int v)
{
    for(int i:ver[v])
        lvl[i]=lvl[v]+1, mlvl=max(mlvl, lvl[i]), dfs(i);
}

void find_dfs(int v, int l)
{
    if(lvl[v]==l)
    {
        if(v>=ansl&&v<=ansr)
            ans=1;
        return;
    }
    for(int i:ver[v])
        find_dfs(i, l);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int x, y;
    cin>>n;
    for(int i=2; i<=n; ++i)
    {
        cin>>x;
        p[i]=x;
        ver[x].push_back(i);
    }
    for(int i=1; i<=n; ++i)
        sort(ver[i].begin(), ver[i].end());
    lvl[1]=1;
    dfs(1);
    //for(int i=1; i<=n; ++i) cout<<lvl[i]<<" ";
    //cout<<endl;
    cin>>q;
    for(int i=0; i<q; ++i)
    {
        cin>>x>>y;
        a[i]= {x, y};
    }
    sort(a, a+q);
    if(mlvl==n)
    {
        cout<<a[q-1].v+a[q-1].d<<" "<<a[0].v+a[0].d<<endl;
        return 0;
    }
    int a1=1, a2=n;
    for(int i=1; i<=n; ++i)
    {
        int jl=i, jr=n, m;
        while(jl<=jr)
        {
            m=(jl+jr)/2;
            int w=0;
            ansl=i, ansr=m;
            for(int k=0; k<q; ++k)
            {
                ans=0;
                find_dfs(a[k].v, lvl[a[k].v]+a[k].d);
                if(!ans)
                {
                    w=1;
                    break;
                }
            }
            if(!w)
            {
                if(a2-a1==m-i)
                {
                    if(a1>i)
                        a1=i, a2=m;
                }
                else if(a2-a1>m-i)
                    a1=i, a2=m;
                jr=m-1;
            }
            else jl=m+1;
        }
    }
    cout<<a1<<" "<<a2<<endl;
    return 0;
}
/*
10
1 2 1 2 4 4 1 4 8
4
1 2
1 1
4 1
8 1
*/
